blob: e40b570b91a3e98f448bbdd05913763b835c540e [file] [log] [blame]
garciadeblas16304ba2016-05-11 14:47:39 +02001#!/bin/bash
2
3##
4# Copyright 2015 Telefónica Investigación y Desarrollo, S.A.U.
5# This file is part of openmano
6# All Rights Reserved.
7#
8# Licensed under the Apache License, Version 2.0 (the "License"); you may
9# not use this file except in compliance with the License. You may obtain
10# a copy of the License at
11#
12# http://www.apache.org/licenses/LICENSE-2.0
13#
14# Unless required by applicable law or agreed to in writing, software
15# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
16# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
17# License for the specific language governing permissions and limitations
18# under the License.
19#
20# For those usages not covered by the Apache License, Version 2.0 please
21# contact with: nfvlabs@tid.es
22##
23
tierno76841842016-09-27 09:18:28 +000024#ONLY TESTED in Ubuntu 16.04 partially tested in Ubuntu 14.10 14.04 16.04, CentOS7 and RHEL7
garciadeblas16304ba2016-05-11 14:47:39 +020025#Get needed packages, source code and configure to run openmano
26#Ask for database user and password if not provided
garciadeblas16304ba2016-05-11 14:47:39 +020027
28function usage(){
tiernoc50e5da2016-07-06 17:49:45 +020029 echo -e "usage: sudo $0 [OPTIONS]"
tierno45a52852016-08-26 14:39:42 +020030 echo -e "Install last stable source code in ./openmano and the needed packages"
31 echo -e "On a Ubuntu 16.04 it configures openmano as a service"
tiernoc50e5da2016-07-06 17:49:45 +020032 echo -e " OPTIONS"
tierno45a52852016-08-26 14:39:42 +020033 echo -e " -u USER: database admin user. 'root' by default. Prompts if needed"
34 echo -e " -p PASS: database admin password to be used or installed. Prompts if needed"
garciadeblas89b3d842016-09-19 15:18:33 +020035 echo -e " -q --quiet: install in unattended mode"
tierno45a52852016-08-26 14:39:42 +020036 echo -e " -h --help: show this help"
37 echo -e " --develop: install last version for developers, and do not configure as a service"
tierno26777652016-11-15 17:33:13 +000038 echo -e " --forcedb: reinstall mano_db DB, deleting previous database if exists and creating a new one"
39 echo -e " --force: makes idenpotent, delete previous installations folders if needed"
garciadeblas89b3d842016-09-19 15:18:33 +020040 echo -e " --noclone: assumes that openmano was cloned previously and that this script is run from the local repo"
tierno76841842016-09-27 09:18:28 +000041 echo -e " --no-install-packages: use this option to skip updating and installing the requires packages. This avoid wasting time if you are sure requires packages are present e.g. because of a previous installation"
garciadeblas16304ba2016-05-11 14:47:39 +020042}
43
44function install_packages(){
45 [ -x /usr/bin/apt-get ] && apt-get install -y $*
tiernoc50e5da2016-07-06 17:49:45 +020046 [ -x /usr/bin/yum ] && yum install -y $*
garciadeblas16304ba2016-05-11 14:47:39 +020047
48 #check properly installed
49 for PACKAGE in $*
50 do
51 PACKAGE_INSTALLED="no"
52 [ -x /usr/bin/apt-get ] && dpkg -l $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
53 [ -x /usr/bin/yum ] && yum list installed $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
54 if [ "$PACKAGE_INSTALLED" = "no" ]
55 then
tiernoc50e5da2016-07-06 17:49:45 +020056 echo "failed to install package '$PACKAGE'. Revise network connectivity and try again" >&2
garciadeblas89b3d842016-09-19 15:18:33 +020057 exit 1
garciadeblas16304ba2016-05-11 14:47:39 +020058 fi
59 done
60}
61
garciadeblas89b3d842016-09-19 15:18:33 +020062function db_exists() {
63 RESULT=`mysqlshow --defaults-extra-file="$2" | grep -v Wildcard | grep -o $1`
64 if [ "$RESULT" == "$1" ]; then
65 echo " DB $1 exists"
66 return 0
67 fi
68 echo " DB $1 does not exist"
69 return 1
70}
71
tierno45a52852016-08-26 14:39:42 +020072GIT_URL=https://osm.etsi.org/gerrit/osm/RO.git
garciadeblasc53ebfa2017-03-31 16:02:13 +020073GIT_OVIM_URL=https://osm.etsi.org/gerrit/osm/openvim.git
tiernoc50e5da2016-07-06 17:49:45 +020074DBUSER="root"
75DBPASSWD=""
76DBPASSWD_PARAM=""
77QUIET_MODE=""
tierno45a52852016-08-26 14:39:42 +020078DEVELOP=""
garciadeblas89b3d842016-09-19 15:18:33 +020079FORCEDB=""
tierno26777652016-11-15 17:33:13 +000080FORCE=""
garciadeblas89b3d842016-09-19 15:18:33 +020081NOCLONE=""
tierno76841842016-09-27 09:18:28 +000082NO_PACKAGES=""
tiernoc50e5da2016-07-06 17:49:45 +020083while getopts ":u:p:hiq-:" o; do
84 case "${o}" in
85 u)
86 export DBUSER="$OPTARG"
87 ;;
88 p)
89 export DBPASSWD="$OPTARG"
90 export DBPASSWD_PARAM="-p$OPTARG"
91 ;;
92 q)
93 export QUIET_MODE=yes
94 export DEBIAN_FRONTEND=noninteractive
95 ;;
96 h)
97 usage && exit 0
98 ;;
99 -)
100 [ "${OPTARG}" == "help" ] && usage && exit 0
tierno45a52852016-08-26 14:39:42 +0200101 [ "${OPTARG}" == "develop" ] && DEVELOP="y" && continue
garciadeblas89b3d842016-09-19 15:18:33 +0200102 [ "${OPTARG}" == "forcedb" ] && FORCEDB="y" && continue
tierno26777652016-11-15 17:33:13 +0000103 [ "${OPTARG}" == "force" ] && FORCEDB="y" && FORCE="y" && continue
garciadeblas89b3d842016-09-19 15:18:33 +0200104 [ "${OPTARG}" == "noclone" ] && NOCLONE="y" && continue
tierno45a52852016-08-26 14:39:42 +0200105 [ "${OPTARG}" == "quiet" ] && export QUIET_MODE=yes && export DEBIAN_FRONTEND=noninteractive && continue
tierno76841842016-09-27 09:18:28 +0000106 [ "${OPTARG}" == "no-install-packages" ] && export NO_PACKAGES=yes && continue
tiernoc50e5da2016-07-06 17:49:45 +0200107 echo -e "Invalid option: '--$OPTARG'\nTry $0 --help for more information" >&2
108 exit 1
109 ;;
110 \?)
111 echo -e "Invalid option: '-$OPTARG'\nTry $0 --help for more information" >&2
112 exit 1
113 ;;
114 :)
115 echo -e "Option '-$OPTARG' requires an argument\nTry $0 --help for more information" >&2
116 exit 1
117 ;;
118 *)
119 usage >&2
garciadeblas89b3d842016-09-19 15:18:33 +0200120 exit 1
tiernoc50e5da2016-07-06 17:49:45 +0200121 ;;
122 esac
123done
garciadeblas16304ba2016-05-11 14:47:39 +0200124
tiernoc50e5da2016-07-06 17:49:45 +0200125#check root privileges and non a root user behind
garciadeblas89b3d842016-09-19 15:18:33 +0200126[ "$USER" != "root" ] && echo "Needed root privileges" >&2 && exit 1
tiernoc50e5da2016-07-06 17:49:45 +0200127if [[ -z "$SUDO_USER" ]] || [[ "$SUDO_USER" = "root" ]]
128then
129 [[ -z $QUIET_MODE ]] && read -e -p "Install in the root user (y/N)?" KK
130 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
131 export SUDO_USER=root
132fi
garciadeblas16304ba2016-05-11 14:47:39 +0200133
134#Discover Linux distribution
135#try redhat type
136[ -f /etc/redhat-release ] && _DISTRO=$(cat /etc/redhat-release 2>/dev/null | cut -d" " -f1)
137#if not assuming ubuntu type
138[ -f /etc/redhat-release ] || _DISTRO=$(lsb_release -is 2>/dev/null)
139if [ "$_DISTRO" == "Ubuntu" ]
140then
tierno45a52852016-08-26 14:39:42 +0200141 _RELEASE=$(lsb_release -rs)
142 if [[ ${_RELEASE%%.*} != 14 ]] && [[ ${_RELEASE%%.*} != 16 ]]
garciadeblas16304ba2016-05-11 14:47:39 +0200143 then
tierno45a52852016-08-26 14:39:42 +0200144 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Ubuntu version. Continue assuming a trusty (14.XX)'? (y/N)" KK
tiernoc50e5da2016-07-06 17:49:45 +0200145 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
tierno45a52852016-08-26 14:39:42 +0200146 _RELEASE = 14
garciadeblas16304ba2016-05-11 14:47:39 +0200147 fi
148elif [ "$_DISTRO" == "CentOS" ]
149then
150 _RELEASE="7"
151 if ! cat /etc/redhat-release | grep -q "7."
152 then
tiernoc50e5da2016-07-06 17:49:45 +0200153 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested CentOS version. Continue assuming a '_RELEASE' type? (y/N)" KK
154 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
garciadeblas16304ba2016-05-11 14:47:39 +0200155 fi
156elif [ "$_DISTRO" == "Red" ]
157then
158 _RELEASE="7"
159 if ! cat /etc/redhat-release | grep -q "7."
160 then
tiernoc50e5da2016-07-06 17:49:45 +0200161 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Red Hat OS version. Continue assuming a '_RELEASE' type? (y/N)" KK
162 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
garciadeblas16304ba2016-05-11 14:47:39 +0200163 fi
164else #[ "$_DISTRO" != "Ubuntu" -a "$_DISTRO" != "CentOS" -a "$_DISTRO" != "Red" ]
165 _DISTRO_DISCOVER=$_DISTRO
166 [ -x /usr/bin/apt-get ] && _DISTRO="Ubuntu" && _RELEASE="14"
167 [ -x /usr/bin/yum ] && _DISTRO="CentOS" && _RELEASE="7"
tiernoc50e5da2016-07-06 17:49:45 +0200168 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Linux distribution '$_DISTRO_DISCOVER '. Continue assuming a '$_DISTRO $_RELEASE' type? (y/N)" KK
169 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
garciadeblas16304ba2016-05-11 14:47:39 +0200170fi
171
tierno26777652016-11-15 17:33:13 +0000172#check if installed as a service
173INSTALL_AS_A_SERVICE=""
174[[ "$_DISTRO" == "Ubuntu" ]] && [[ ${_RELEASE%%.*} == 16 ]] && [[ -z $DEVELOP ]] && INSTALL_AS_A_SERVICE="y"
175#Next operations require knowing OPENMANO_BASEFOLDER
176if [[ -z "$NOCLONE" ]]; then
tiernoaa5832d2016-12-07 16:20:25 +0100177 if [[ -n "$INSTALL_AS_A_SERVICE" ]] ; then
178 OPENMANO_BASEFOLDER=__openmano__${RANDOM}
179 else
180 OPENMANO_BASEFOLDER="${PWD}/openmano"
181 fi
182 [[ -n "$FORCE" ]] && rm -rf $OPENMANO_BASEFOLDER #make idempotent
tierno26777652016-11-15 17:33:13 +0000183else
184 HERE=$(realpath $(dirname $0))
185 OPENMANO_BASEFOLDER=$(dirname $HERE)
186fi
garciadeblas16304ba2016-05-11 14:47:39 +0200187
188
tierno76841842016-09-27 09:18:28 +0000189if [[ -z "$NO_PACKAGES" ]]
190then
garciadeblas16304ba2016-05-11 14:47:39 +0200191echo '
192#################################################################
193##### UPDATE REPOSITORIES #####
194#################################################################'
195[ "$_DISTRO" == "Ubuntu" ] && apt-get update -y
196
197[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && yum check-update -y
198[ "$_DISTRO" == "CentOS" ] && sudo yum install -y epel-release
199[ "$_DISTRO" == "Red" ] && wget http://dl.fedoraproject.org/pub/epel/7/x86_64/e/epel-release-7-5.noarch.rpm \
200 && sudo rpm -ivh epel-release-7-5.noarch.rpm && sudo yum install -y epel-release && rm -f epel-release-7-5.noarch.rpm
201[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && sudo yum repolist
202
tierno76841842016-09-27 09:18:28 +0000203fi
garciadeblas16304ba2016-05-11 14:47:39 +0200204
tierno76841842016-09-27 09:18:28 +0000205if [[ -z "$NO_PACKAGES" ]]
206then
garciadeblas16304ba2016-05-11 14:47:39 +0200207echo '
208#################################################################
209##### INSTALL REQUIRED PACKAGES #####
210#################################################################'
garciadeblasc53ebfa2017-03-31 16:02:13 +0200211[ "$_DISTRO" == "Ubuntu" ] && install_packages "git make screen wget mysql-server"
212[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "git make screen wget mariadb mariadb-server"
garciadeblas16304ba2016-05-11 14:47:39 +0200213
tiernoc50e5da2016-07-06 17:49:45 +0200214if [[ "$_DISTRO" == "Ubuntu" ]]
215then
216 #start services. By default CentOS does not start services
217 service mysql start >> /dev/null
218 # try to set admin password, ignore if fails
219 [[ -n $DBPASSWD ]] && mysqladmin -u $DBUSER -s password $DBPASSWD
220fi
221
garciadeblas16304ba2016-05-11 14:47:39 +0200222if [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ]
223then
224 #start services. By default CentOS does not start services
225 service mariadb start
226 service httpd start
227 systemctl enable mariadb
228 systemctl enable httpd
229 read -e -p "Do you want to configure mariadb (recommended if not done before) (Y/n)" KK
230 [ "$KK" != "n" -a "$KK" != "no" ] && mysql_secure_installation
231
232 read -e -p "Do you want to set firewall to grant web access port 80,443 (Y/n)" KK
233 [ "$KK" != "n" -a "$KK" != "no" ] &&
234 firewall-cmd --permanent --zone=public --add-service=http &&
235 firewall-cmd --permanent --zone=public --add-service=https &&
236 firewall-cmd --reload
237fi
tierno76841842016-09-27 09:18:28 +0000238fi #[[ -z "$NO_PACKAGES" ]]
garciadeblas16304ba2016-05-11 14:47:39 +0200239
240#check and ask for database user password. Must be done after database installation
tiernoc50e5da2016-07-06 17:49:45 +0200241if [[ -n $QUIET_MODE ]]
242then
243 echo -e "\nCheking database connection and ask for credentials"
garciadeblas89b3d842016-09-19 15:18:33 +0200244 while ! mysqladmin -s -u$DBUSER $DBPASSWD_PARAM status >/dev/null
tiernoc50e5da2016-07-06 17:49:45 +0200245 do
garciadeblas16304ba2016-05-11 14:47:39 +0200246 [ -n "$logintry" ] && echo -e "\nInvalid database credentials!!!. Try again (Ctrl+c to abort)"
247 [ -z "$logintry" ] && echo -e "\nProvide database credentials"
248 read -e -p "database user? ($DBUSER) " DBUSER_
249 [ -n "$DBUSER_" ] && DBUSER=$DBUSER_
250 read -e -s -p "database password? (Enter for not using password) " DBPASSWD_
tiernoc50e5da2016-07-06 17:49:45 +0200251 [ -n "$DBPASSWD_" ] && DBPASSWD="$DBPASSWD_" && DBPASSWD_PARAM="-p$DBPASSWD_"
252 [ -z "$DBPASSWD_" ] && DBPASSWD="" && DBPASSWD_PARAM=""
garciadeblas16304ba2016-05-11 14:47:39 +0200253 logintry="yes"
tiernoc50e5da2016-07-06 17:49:45 +0200254 done
255fi
garciadeblas16304ba2016-05-11 14:47:39 +0200256
tierno76841842016-09-27 09:18:28 +0000257if [[ -z "$NO_PACKAGES" ]]
258then
garciadeblas16304ba2016-05-11 14:47:39 +0200259echo '
260#################################################################
261##### INSTALL PYTHON PACKAGES #####
262#################################################################'
bayramovfe3f3c92016-10-04 07:53:41 +0400263[ "$_DISTRO" == "Ubuntu" ] && install_packages "python-yaml python-bottle python-mysqldb python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxml2-dev libxslt-dev python-dev python-pip"
264[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "PyYAML MySQL-python python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxslt-devel libxml2-devel python-devel python-pip"
tiernof70d0962017-01-30 12:39:09 +0100265#The only way to install python-bottle on Centos7 is with easy_install or pip
266[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && easy_install -U bottle
bayramovfe3f3c92016-10-04 07:53:41 +0400267
268#required for vmware connector TODO move that to separete opt in install script
269sudo pip install --upgrade pip
270sudo pip install pyvcloud
271sudo pip install progressbar
272sudo pip install prettytable
bhangarefda5f7c2017-01-12 23:50:34 -0800273sudo pip install pyvmomi
garciadeblas16304ba2016-05-11 14:47:39 +0200274
tiernof70d0962017-01-30 12:39:09 +0100275#requiered for AWS connector
276[ "$_DISTRO" == "Ubuntu" ] && install_packages "python-boto"
277[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-boto" #TODO check if at Centos it exist with this name, or PIP should be used
garciadeblas16304ba2016-05-11 14:47:39 +0200278
279#install openstack client needed for using openstack as a VIM
tierno93bffb42016-12-31 17:08:51 +0100280[ "$_DISTRO" == "Ubuntu" ] && install_packages "python-novaclient python-keystoneclient python-glanceclient python-neutronclient python-cinderclient"
281[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-devel" && easy_install python-novaclient python-keystoneclient python-glanceclient python-neutronclient python-cinderclient #TODO revise if gcc python-pip is needed
tierno76841842016-09-27 09:18:28 +0000282fi #[[ -z "$NO_PACKAGES" ]]
garciadeblas16304ba2016-05-11 14:47:39 +0200283
garciadeblas89b3d842016-09-19 15:18:33 +0200284if [[ -z $NOCLONE ]]; then
285 echo '
garciadeblas16304ba2016-05-11 14:47:39 +0200286#################################################################
287##### DOWNLOAD SOURCE #####
288#################################################################'
tierno26777652016-11-15 17:33:13 +0000289 su $SUDO_USER -c "git clone ${GIT_URL} ${OPENMANO_BASEFOLDER}"
290 su $SUDO_USER -c "cp ${OPENMANO_BASEFOLDER}/.gitignore-common ${OPENMANO_BASEFOLDER}/.gitignore"
garciadeblasc53ebfa2017-03-31 16:02:13 +0200291 [[ -z $DEVELOP ]] && su $SUDO_USER -c "git -C ${OPENMANO_BASEFOLDER} checkout tags/v1.1.0"
garciadeblas89b3d842016-09-19 15:18:33 +0200292fi
garciadeblas16304ba2016-05-11 14:47:39 +0200293
294echo '
295#################################################################
garciadeblasc53ebfa2017-03-31 16:02:13 +0200296##### INSTALLING OVIM LIBRARY #####
297#################################################################'
298su $SUDO_USER -c "git -C ${OPENMANO_BASEFOLDER} clone ${GIT_OVIM_URL} openvim"
299[[ -z $DEVELOP ]] && su $SUDO_USER -c "git -C ${OPENMANO_BASEFOLDER}/openvim checkout master"
300# Install debian dependencies before setup.py
301#[ "$_DISTRO" == "Ubuntu" ] && install_packages "git"
302#[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "git"
303make -C ${OPENMANO_BASEFOLDER}/openvim lite
304
305echo '
306#################################################################
garciadeblas16304ba2016-05-11 14:47:39 +0200307##### CREATE DATABASE #####
308#################################################################'
garciadeblas89b3d842016-09-19 15:18:33 +0200309echo -e "\nCreating temporary file form MYSQL installation and initialization"
310TEMPFILE="$(mktemp -q --tmpdir "installopenmano.XXXXXX")"
garciadeblas4b3b4462016-09-27 11:16:14 +0200311trap 'rm -f "$TEMPFILE"' EXIT
garciadeblas89b3d842016-09-19 15:18:33 +0200312chmod 0600 "$TEMPFILE"
tierno26777652016-11-15 17:33:13 +0000313echo -e "[client]\n user='$DBUSER'\n password='$DBPASSWD'">"$TEMPFILE"
garciadeblas16304ba2016-05-11 14:47:39 +0200314
tierno12b1f742016-09-19 15:43:53 +0000315if db_exists "mano_db" $TEMPFILE ; then
garciadeblas89b3d842016-09-19 15:18:33 +0200316 if [[ -n $FORCEDB ]]; then
317 echo " Deleting previous database mano_db"
318 DBDELETEPARAM=""
319 [[ -n $QUIET_MODE ]] && DBDELETEPARAM="-f"
320 mysqladmin --defaults-extra-file=$TEMPFILE -s drop mano_db $DBDELETEPARAM || ! echo "Could not delete mano_db database" || exit 1
321 #echo "REVOKE ALL PRIVILEGES ON mano_db.* FROM 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
322 #echo "DELETE USER 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
323 mysqladmin --defaults-extra-file=$TEMPFILE -s create mano_db || ! echo "Error creating mano_db database" || exit 1
324 echo "DROP USER 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
325 echo "CREATE USER 'mano'@'localhost' identified by 'manopw';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
326 echo "GRANT ALL PRIVILEGES ON mano_db.* TO 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
327 echo " Database 'mano_db' created, user 'mano' password 'manopw'"
328 else
329 echo "Database exists. Use option '--forcedb' to force the deletion of the existing one" && exit 1
330 fi
331else
tierno12b1f742016-09-19 15:43:53 +0000332 mysqladmin -u$DBUSER $DBPASSWD_PARAM -s create mano_db || ! echo "Error creating mano_db database" || exit 1
garciadeblas89b3d842016-09-19 15:18:33 +0200333 echo "CREATE USER 'mano'@'localhost' identified by 'manopw';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
334 echo "GRANT ALL PRIVILEGES ON mano_db.* TO 'mano'@'localhost';" | mysql --defaults-extra-file=$TEMPFILE -s || ! echo "Failed while creating user mano at database" || exit 1
335 echo " Database 'mano_db' created, user 'mano' password 'manopw'"
336fi
garciadeblas16304ba2016-05-11 14:47:39 +0200337
garciadeblas89b3d842016-09-19 15:18:33 +0200338
339echo '
340#################################################################
341##### INIT DATABASE #####
342#################################################################'
garciadeblasc53ebfa2017-03-31 16:02:13 +0200343su $SUDO_USER -c "${OPENMANO_BASEFOLDER}/database_utils/init_mano_db.sh -u mano -p manopw -d mano_db" || ! echo "Failed while initializing main database" || exit 1
garciadeblas89b3d842016-09-19 15:18:33 +0200344
garciadeblasc53ebfa2017-03-31 16:02:13 +0200345echo '
346#################################################################
347##### CREATE AND INIT MANO_VIM DATABASE #####
348#################################################################'
349# Install mano_vim_db after setup
350su $SUDO_USER -c "${OPENMANO_BASEFOLDER}/openvim/database_utils/install-db-server.sh -U $DBUSER ${DBPASSWD_PARAM/p/P} -u mano -p manopw -d mano_vim_db" || ! echo "Failed while installing ovim database" || exit 1
garciadeblas16304ba2016-05-11 14:47:39 +0200351
352if [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ]
353then
354 echo '
355#################################################################
356##### CONFIGURE firewalld #####
357#################################################################'
tiernoc50e5da2016-07-06 17:49:45 +0200358 KK=yes
359 [[ -z $QUIET_MODE ]] && read -e -p "Configure firewalld for openmanod port 9090? (Y/n)" KK
garciadeblas16304ba2016-05-11 14:47:39 +0200360 if [ "$KK" != "n" -a "$KK" != "no" ]
361 then
362 #Creates a service file for openmano
363 echo '<?xml version="1.0" encoding="utf-8"?>
364<service>
365 <short>openmanod</short>
366 <description>openmanod service</description>
367 <port protocol="tcp" port="9090"/>
368</service>' > /etc/firewalld/services/openmanod.xml
369 #put proper permissions
370 pushd /etc/firewalld/services > /dev/null
371 restorecon openmanod.xml
372 chmod 640 openmanod.xml
373 popd > /dev/null
374 #Add the openmanod service to the default zone permanently and reload the firewall configuration
375 firewall-cmd --permanent --add-service=openmanod > /dev/null
376 firewall-cmd --reload > /dev/null
377 echo "done."
378 else
379 echo "skipping."
380 fi
381fi
382
383echo '
384#################################################################
385##### CONFIGURE OPENMANO CLIENT #####
386#################################################################'
tierno26777652016-11-15 17:33:13 +0000387#creates a link at ~/bin if not configured as a service
388if [[ -z "$INSTALL_AS_A_SERVICE" ]]
tiernoc50e5da2016-07-06 17:49:45 +0200389then
tierno26777652016-11-15 17:33:13 +0000390 su $SUDO_USER -c 'mkdir -p ${HOME}/bin'
391 su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano'
392 su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano-report'
393 su $SUDO_USER -c 'rm -f ${HOME}/bin/service-openmano'
tiernoaa5832d2016-12-07 16:20:25 +0100394 su $SUDO_USER -c "ln -s '${OPENMANO_BASEFOLDER}/openmano' "'${HOME}/bin/openmano'
395 su $SUDO_USER -c "ln -s '${OPENMANO_BASEFOLDER}/scripts/openmano-report.sh' "'${HOME}/bin/openmano-report'
396 su $SUDO_USER -c "ln -s '${OPENMANO_BASEFOLDER}/scripts/service-openmano.sh' "'${HOME}/bin/service-openmano'
tierno26777652016-11-15 17:33:13 +0000397
398 #insert /home/<user>/bin in the PATH
399 #skiped because normally this is done authomatically when ~/bin exist
400 #if ! su $SUDO_USER -c 'echo $PATH' | grep -q "${HOME}/bin"
401 #then
402 # echo " inserting /home/$SUDO_USER/bin in the PATH at .bashrc"
403 # su $SUDO_USER -c 'echo "PATH=\$PATH:\${HOME}/bin" >> ~/.bashrc'
404 #fi
405 if [[ $SUDO_USER == root ]]
tiernoc50e5da2016-07-06 17:49:45 +0200406 then
tierno26777652016-11-15 17:33:13 +0000407 if ! echo $PATH | grep -q "${HOME}/bin"
408 then
409 echo "PATH=\$PATH:\${HOME}/bin" >> ${HOME}/.bashrc
410 fi
411 fi
412fi
garciadeblas16304ba2016-05-11 14:47:39 +0200413
414#configure arg-autocomplete for this user
415#in case of minimal instalation this package is not installed by default
416[[ "$_DISTRO" == "CentOS" || "$_DISTRO" == "Red" ]] && yum install -y bash-completion
417#su $SUDO_USER -c 'mkdir -p ~/.bash_completion.d'
418su $SUDO_USER -c 'activate-global-python-argcomplete --user'
tiernoc50e5da2016-07-06 17:49:45 +0200419if ! su $SUDO_USER -c 'grep -q bash_completion.d/python-argcomplete.sh ${HOME}/.bashrc'
garciadeblas16304ba2016-05-11 14:47:39 +0200420then
421 echo " inserting .bash_completion.d/python-argcomplete.sh execution at .bashrc"
tiernoc50e5da2016-07-06 17:49:45 +0200422 su $SUDO_USER -c 'echo ". ${HOME}/.bash_completion.d/python-argcomplete.sh" >> ~/.bashrc'
garciadeblas16304ba2016-05-11 14:47:39 +0200423fi
424
tierno45a52852016-08-26 14:39:42 +0200425
426
427
tierno26777652016-11-15 17:33:13 +0000428if [[ -n "$INSTALL_AS_A_SERVICE" ]]
tierno45a52852016-08-26 14:39:42 +0200429then
430echo '
431#################################################################
432##### CONFIGURE OPENMANO SERVICE #####
433#################################################################'
434
tiernoaa5832d2016-12-07 16:20:25 +0100435 ${OPENMANO_BASEFOLDER}/scripts/install-openmano-service.sh -f ${OPENMANO_BASEFOLDER} `[[ -z "$NOCLONE" ]] && echo "-d"`
tierno26777652016-11-15 17:33:13 +0000436# rm -rf ${OPENMANO_BASEFOLDER}
tierno45a52852016-08-26 14:39:42 +0200437# alias service-openmano="service openmano"
438# echo 'alias service-openmano="service openmano"' >> ${HOME}/.bashrc
439
440 echo
tierno26777652016-11-15 17:33:13 +0000441 echo "Done! installed at /opt/openmano"
442 echo " Manage server with 'sudo service openmano start|stop|status|...' "
tierno45a52852016-08-26 14:39:42 +0200443
444
445else
446
447 echo
448 echo "Done! you may need to logout and login again for loading client configuration"
tierno26777652016-11-15 17:33:13 +0000449 echo " Run './${OPENMANO_BASEFOLDER}/scripts/service-openmano.sh start' for starting openmano in a screen"
tierno45a52852016-08-26 14:39:42 +0200450
451fi
garciadeblas16304ba2016-05-11 14:47:39 +0200452
453
454